#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const int N = 2e5;
vector<vector<int>> g;
int ti[N];
void dfs(int v, int p){
    for (auto u: g[v]) {
        if(u == p)
            continue;
        ti[u] = ti[v]+1;
        dfs(u, v);
    }
}
int getd(int s, int n){
    int curr = 0;
    vector<int> d(n, 0);
    vector<char> u(n, 0);
    queue<int> q;
    q.push(s);
    while (!q.empty()){
        int v = q.front();
        u[v] = 1;
        q.pop();
        for (auto to: g[v]) {
            if(u[to] || ti[to] < ti[v]) continue;
            u[to] = 1;
            d[to] = d[v] + 1;
            curr = max(curr, d[to]);
            q.push(to);
        }
    }
    return curr;
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    int n, k, t;
    cin >> n >> k >> t;
    g.resize(n+1);
    for (int i = 0; i < n-1; ++i) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    if(k == 1 && t == 0 && n<=2000){
        int ans = 1e9;
        dfs(0, -1);
        ti[0] = 0;
        for (int i = 1; i < n; ++i) {
            g[0].push_back(i);
            ans = min(ans, getd(0, n));
            g[0].pop_back();
        }
        cout << ans << ' ';
    }else if(n <= 16){
        vector<int> ans(n, 1e9);
        for (int i = 0; i < n - (t^1) * (n-1); ++i) {
            ti[i] = 0;
            dfs(i, -1);
            for (int j = 0; j < (1<<n); ++j) {
                vector<int> ord_to_push;ord_to_push.clear();
                bool check = 0;
                for (int l = 0; l < n; ++l) {
                    if(((1<<l) | j) == j){
                        ord_to_push.push_back(l);
                        if(l==i)
                            check = 1;
                    }
                }
                if(ord_to_push.size()!=k || check)
                    continue;
                for(auto uv : ord_to_push){
                    g[i].push_back(uv);
                }
                ans[i] = min(ans[i], getd(i, n));
                for(auto uv : ord_to_push){
                    g[i].pop_back();
                }

            }
            cout << ans[i] << ' ';
        }
    }else{
        cout << max(1, ((n-2+k-1)/k));
    }
}