#include <bits/stdc++.h>
using namespace std;
using ll = long long;
vector<vector<int>> g;
int getd(int s, int n){
    int curr = 0;
    vector<int> d(n, 0);
    vector<char> u(n, 0);
    queue<int> q;
    q.push(s);
    while (!q.empty()){
        int v = q.front();
        u[v] = 1;
        q.pop();
        for (auto to: g[v]) {
            if(u[to]) continue;
            u[to] = 1;
            d[to] = d[v] + 1;
            curr = max(curr, d[to]);
            q.push(to);
        }
    }
    return curr;
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    int n, k, t;
    cin >> n >> k >> t;
    g.resize(n);
    for (int i = 0; i < n-1; ++i) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    if(k == 1 && t == 0){
        int ans = 1e9;
        for (int i = 1; i < n; ++i) {
            g[0].push_back(i);
            g[i].push_back(0);
            ans = min(ans, getd(0, n));
            g[0].pop_back();
            g[i].pop_back();
        }
        cout << ans;
    }else if(n <= 16){
        vector<int> ans(n, 1e9);
        for (int i = 0; i < n; ++i) {

            for (int j = 0; j < (1<<n); ++j) {
                vector<int> ord_to_push;
                bool check = 0;
                for (int l = 0; l < n; ++l) {
                    if(((1<<l) & j) == (1<<l)){
                        ord_to_push.push_back(l);
                        if(l==i)
                            check = 1;
                    }
                }
                if(ord_to_push.size()!=k || check)
                    continue;
                for(auto uv : ord_to_push){
                    g[i].push_back(uv);
                    g[uv].push_back(i);
                }
                ans[i] = min(ans[i], getd(i, n));
                for(auto uv : ord_to_push){
                    g[i].pop_back();
                    g[uv].pop_back();
                }
            }
        }
        for (auto &e : ans) {
            cout << e << ' ';
        }
    }else{
        cout << max((n-1)/k - 1, 1);
    }
}
/*
 4 1 1
 1 2
 1 3
 1 4

 */